"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStore = void 0;
const react_1 = require("react");
const observe_1 = require("./observe");
/**
 * This function give you an store, use that in your components which want to
 * connect to store and provider
 */
exports.createStore = ({ reducer, initialState, }) => {
    const stateContext = observe_1.createObserveContext(initialState);
    const dispatchContext = react_1.createContext(() => { });
    const store = {
        stateContext,
        dispatchContext,
        reducer,
        initialState,
        useState: (nextObserveState) => {
            return observe_1.useObserveContext(stateContext, nextObserveState);
        },
        useDispatch: () => react_1.useContext(dispatchContext),
    };
    return store;
};
//# sourceMappingURL=createStore.js.map