"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProvidersList = exports.Provider = void 0;
const react_1 = __importStar(require("react"));
const Provider = react_1.memo(react_1.forwardRef(({ children, store, onStateDidChange, initializer }, ref) => {
    const { reducer, initialState, stateContext, dispatchContext, } = store;
    const [state, dispatch] = react_1.useReducer(reducer, initialState, initializer);
    const lastAction = react_1.useRef();
    const dispatchWrapped = react_1.useCallback((action) => {
        lastAction.current = action;
        // @ts-ignore
        dispatch(action);
    }, []);
    useHandleRef(ref, {
        state,
        dispatch: dispatchWrapped,
    });
    react_1.useEffect(() => {
        if (lastAction.current)
            onStateDidChange?.(state, lastAction.current);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [state]);
    return (react_1.default.createElement(dispatchContext.Provider, { value: dispatchWrapped },
        react_1.default.createElement(stateContext.Provider, { value: state }, children)));
}));
exports.Provider = Provider;
function useHandleRef(ref, object) {
    react_1.useMemo(() => {
        if (ref && "current" in ref) {
            ref.current = object;
        }
        else if (typeof ref === "function") {
            ref(object);
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [ref, Object.values(object)]);
}
function ProvidersList({ children, providers = [] }) {
    return providers.reduce((previousValue, Current) => {
        return react_1.default.createElement(Current, null, previousValue);
    }, children);
}
exports.ProvidersList = ProvidersList;
//# sourceMappingURL=provider.js.map